#include	"plot.h"
#include	<stdio.h>

/*
  Write text string using the device's native font.
*/

pftextd_( xc, yc, angle, size, text, textlen )
float	*xc;
float	*yc;
float	*angle;
float	*size;
char	*text;
int	textlen;
{
  int		device_x, backstore, device_ps;
  int		xp, yp;
  float		wx, wy;
  float		w;
  char		font_name[64];
  Font		font;
  FILE		*fp;
  int		strlen;
  int		strlenf_();
  float		font_size;
  int		font_numb;
  char		str[256];
  FILE		*plsav_fp();

/* Check the device: Only X or PS are accepted. */

  device_x = FALSE;
  backstore = FALSE;
  device_ps = FALSE;

  if( DEVICE_N == X || DEVICE_N == XM 
		|| DEVICE_N == XN || DEVICE_N == XMN ) {
    device_x = TRUE;
    if( DEVICE_N == X || DEVICE_N == XM ) backstore = TRUE;
  } else if( DEVICE_N == POSTSCRIPT || DEVICE_N == POSTSCRIPTM ) {
    device_ps = TRUE;
  } else {
    return;
  }

/* Convert the scale and check the window */

  if( plscal( 0, *xc, *yc, *xc, *yc, &xp, &yp, &xp, &yp ) ) {

/* Font size */

    wx = *size * ( SCRN_X_H - SCRN_X_L ) / ( WDW_X_H - WDW_X_L );
    wy = *size * ( SCRN_Y_H - SCRN_Y_L ) / ( WDW_Y_H - WDW_Y_L );
    w = ( wx + wy ) * 0.5;

    strlen = strlenf_( text, 255 > textlen ? textlen : 255 );

    if( device_x ) {
/* X window */

/* angle has to be 0 */

      if( *angle != 0.0 ) {
	pftext_( xc, yc, angle, size, &font_numb, text, textlen );
	return;
      }

/* Select a font */

      if( w < 0.015 ) {
	strncpy( font_name, "a14", 4 );
      } else if( w < 0.025 ) {
	strncpy( font_name, "a16", 4 );
      } else if( w < 0.045 ) {
	strncpy( font_name, "a24", 4 );
      } else {
	font_numb = 1;
	pftext_( xc, yc, angle, size, &font_numb, text, textlen );
	return;
      }

      if( ( font = XLoadFont( XDISPLAY, font_name ) ) ) {
/* Success to load a font */
	XSetFont( XDISPLAY, XGC, font );
	yp = XWINDOW_YSIZE - yp + 1;
	XDrawString( XDISPLAY, XWINDOW, XGC, xp, yp, text, strlen );
	if( backstore ) {
	  XSetFont( XDISPLAY, PGC, font );
	  XDrawString( XDISPLAY, XPIXMAP, PGC, xp, yp, text, strlen );
	}
      }
    } else {
/* Postscript */

      fp = plsav_fp( RESTORE, 0 );
      font_size = DSP_X * w;
      fprintf( fp, "/Times-Roman findfont\n" );
      fprintf( fp, "%f scalefont setfont\n", font_size );
      fprintf( fp, "%d %d m\n", xp, yp );
      fprintf( fp, "currentpoint translate\n" );
      fprintf( fp, "%f rotate\n", *angle );
      strncpy( str, text, strlen );
      str[strlen] = 0;
      fprintf( fp, "(%s) show\n", str );
      fprintf( fp, "0 0 m\n" );
      fprintf( fp, "%f rotate\n", -(*angle) );
      fprintf( fp, "%d %d m\n", -xp, -yp );
      fprintf( fp, "currentpoint translate\n" );

    } /* device */
  } /* END plscal OK */
}
